clear all
close all
clc

%codice per graficare le curve di tendenza utili all'analisi statistica
VTOL=["Songbrid 1400" "Mugin 2 Pro"  "RaptorUAS-EV " "Dragon VTOL Plane" "Hunter VTOL" "Baby Shark 260 VTOL"  "FLY-350 VTOL" "FLY-300 Angel Wing VTOL" "Mugin EV 350" "YANGDA FW-320" "YANGDA FW-250" "Maprid VTOL" ];
APERT_ALARE=[3060	2930	3000	2160 2430	2500	3500	3000 3500	3200	2500	2100];
SUP_ALARE=[100	90	84	60 72.5	58.4	70	74 100	112	60	50];
MTOW=[9000	25000	9000	8000 11500	13000	15000	15000 22000	20300	12000	8500];
MAX_PAYLOAD=[2000	6000	1000	1000 1500	2400	1500	2000 3000	3080	2000	1500];
CRUISE_SPEED=[64.8	80	64.8	54 64.8	70	72	93.6 75.6	80	75	72];
MAX_SPEED=[160	112	86.4	80 80	110	110	108 108	100	100	90];
LUNGHEZZA=[1300	1900	1200	1200 1450	1400	1610	1600 1860	1200	1440	1200];
%CARICO_ALARE=[90.00	82.69	88.37	138.89 87.27	66.67	97.22	107.14 203.70	81.25	285.46	177.47];
AUTONOMIA=[70	90	240	90 120	150	120	105 135	150	120	90];

coefficienti=zeros(7,2);
xx=linspace(20,350,10000);
p=polyfit(AUTONOMIA,MTOW,1);
coefficienti(1,:)=p;
q=polyval(p,xx);
figure(1)
plot(AUTONOMIA,MTOW,'b.','markersize',15);
text(AUTONOMIA,MTOW,VTOL);
axis([(min(AUTONOMIA)-0.15*min(AUTONOMIA)) (max(AUTONOMIA)+0.15*max(AUTONOMIA)) (min(MTOW)-0.15*min(MTOW)) (max(MTOW)+0.15*max(MTOW))])
xlabel('Autonomia [min]','fontweight','bold','fontsize',12);
ylabel('MTOW [g]','fontweight','bold','fontsize',12);
title('Autonomia oraria - Peso massimo al decollo');
grid on
hold on
plot(xx,q,'r','linewidth',2)


MATRICE=zeros(6,12);
MATRICE(1,:)=APERT_ALARE; MATRICE(2,:)=SUP_ALARE; MATRICE(3,:)=MAX_PAYLOAD; MATRICE(4,:)=CRUISE_SPEED;
MATRICE(5,:)=MAX_SPEED; MATRICE(6,:)=LUNGHEZZA; % MATRICE(7,:)=CARICO_ALARE
NOMI_VARIABILI=["Apertura alare [mm]","Superficie alare [mm^2]","Payload [g]","Velocit di crociera [km/h]","Velocit massima [km/h]","Lunghezza [mm]"];
NOMI_PER_TITOLI=["Peso massimo al decollo - Apertura alare", "Peso massimo al decollo - Superficie alare", "Peso massimo al decollo - Payload", "Peso massimo al decollo - Velocit di crociera", "Peso massimo al decollo - Velocit massima", "Peso massimo al decollo - Lunghezza"];
for i=1:6
        figure(i+1)
xx=linspace((min(MTOW)-0.15*min(MTOW)),(max(MTOW)+0.15*max(MTOW)),10000);
p=polyfit(MTOW,MATRICE(i,:),1);
coefficienti(i+1,:)=p;
q=polyval(p,xx);
plot(MTOW,MATRICE(i,:),'b.','markersize',15);
text(MTOW,MATRICE(i,:),VTOL);
axis([(min(MTOW)-0.15*min(MTOW)) (max(MTOW)+0.15*max(MTOW)) (min(MATRICE(i,:))-0.15*min(MATRICE(i,:))) (max(MATRICE(i,:))+0.15*max(MATRICE(i,:))) ])
xlabel('MTOW [g]','fontweight','bold','fontsize',12);
ylabel(NOMI_VARIABILI(i),'fontweight','bold','fontsize',12);
title(NOMI_PER_TITOLI(i));
grid on
hold on
plot(xx,q,'r','linewidth',2)
end
        
Peso_massimo_decollo=coefficienti(1,1)*150 + coefficienti(1,2);
grandezze_statistiche=zeros(7,1)
grandezze_statistiche(1)=Peso_massimo_decollo;
for k=2:7
    f=@(x)(coefficienti(k,1).*x +coefficienti(k,2));
    grandezze_statistiche(k)=f(Peso_massimo_decollo);
    
end

coefficienti_2=zeros(1,2);
xx=linspace((min(MAX_PAYLOAD)-0.15*min(MAX_PAYLOAD)),(max(MAX_PAYLOAD)+0.15*max(MAX_PAYLOAD)),10000);
p=polyfit(MAX_PAYLOAD,MTOW,1);
coefficienti_2(1,:)=p;
q=polyval(p,xx);
figure(8)
plot(MAX_PAYLOAD,MTOW,'b.','markersize',15);
text(MAX_PAYLOAD,MTOW,VTOL);
axis([(min(MAX_PAYLOAD)-0.15*min(MAX_PAYLOAD)) (max(MAX_PAYLOAD)+0.15*max(MAX_PAYLOAD)) (min(MTOW)-0.15*min(MTOW)) (max(MTOW)+0.15*max(MTOW))])
xlabel('Payload [g]','fontweight','bold','fontsize',12);
ylabel('MTOW [g]','fontweight','bold','fontsize',12);
title('Payload - Peso massimo al decollo');
grid on
hold on
plot(xx,q,'r','linewidth',2)

coefficienti_3=zeros(1,2);
xx=linspace((min(MTOW)-0.15*min(MTOW)),(max(MTOW)+0.15*max(MTOW)),10000);
p=polyfit(MTOW,AUTONOMIA,1);
coefficienti_3(1,:)=p;
q=polyval(p,xx);
figure(9)
plot(MTOW,AUTONOMIA,'b.','markersize',15);
text(MTOW,AUTONOMIA,VTOL);
axis([(min(MTOW)-0.15*min(MTOW)) (max(MTOW)+0.15*max(MTOW)) (min(AUTONOMIA)-0.15*min(AUTONOMIA)) (max(AUTONOMIA)+0.15*max(AUTONOMIA))])
xlabel('MTOW [g]','fontweight','bold','fontsize',12);
ylabel('Autonomia [min]','fontweight','bold','fontsize',12);
title('Peso massimo al decollo - Autonomia');
grid on
hold on
plot(xx,q,'r','linewidth',2)

Peso_massimo_decollo_2=coefficienti_2(1,1)*2500 + coefficienti_2(1,2);
grandezze_statistiche_2=zeros(7,1)
grandezze_statistiche_2(1)=Peso_massimo_decollo_2;
for k=2:7
    if (k~=4)
    f=@(x)(coefficienti(k,1).*x +coefficienti(k,2));
    grandezze_statistiche_2(k)=f(Peso_massimo_decollo_2);
    else
        f=@(x)(coefficienti_3(1,1).*x +coefficienti_3(1,2));
        grandezze_statistiche_2(k)=f(Peso_massimo_decollo_2);
    end
    
end
% %Calcolo retta di regressione senza considerare il Raptor
% MTOW_2=[9000	4300	3800	6000 4800	6000	3500 2200	6000	13000	2300];
% AUTONOMIA_2=[70	30	59	50 40	120	60 40	60	150	55];
% VTOL_2=["Songbrid 1400"  "Vertex Tiltrotor"  "FireFLY6" "Foxtech Nimbus V2" "Observer VTOL Hybrid" "DeltaQuad One" "Chrysaor VTL-1" "SkyProwler" "Pro S3 ICON" "Baby Shark 260 VTOL"  "SkyProwler 2"];
% 
% coefficienti_4=zeros(1,2);
% xx=linspace((min(MTOW_2)-0.15*min(MTOW_2)),(max(MTOW_2)+0.15*max(MTOW_2)),10000);
% p=polyfit(MTOW_2,AUTONOMIA_2,1);
% coefficienti_4(1,:)=p;
% q=polyval(p,xx);
% figure(10)
% plot(MTOW_2,AUTONOMIA_2,'b.','markersize',15);
% text(MTOW_2,AUTONOMIA_2,VTOL_2);
% axis([1900 13500 10 200])
% xlabel('MTOW [g]','fontweight','bold','fontsize',12);
% ylabel('Autonomia [min]','fontweight','bold','fontsize',12);
% title('Peso massimo al decollo - Autonomia');
% grid on
% hold on
% plot(xx,q,'r','linewidth',2)
% 
% %calcolo autonomia senza considerare il Raptor
% f=@(x)(coefficienti_4(1,1).*x +coefficienti_4(1,2));
% autonomia_no_raptor=f(Peso_massimo_decollo_2);